************************************************************************
*                                                                      *
      SUBROUTINE TERP1(XA,YA,XB,YB,XI,YI,I)
*                                                                      *
*     INTERPOLATE ONE POINT                                            *
*     (XA,YA) AND(XB,YB) ARE THE END POINTS OF THE LINE                *
*     I IS THE INTERPOLATION CODE                                      *
*       =1, Y CONSTANT WITH X                                          *
*       =2, LINEAR X - LINEAR Y                                        *
*       =3, LOG X - LINEAR Y                                           *
*       =4, LINEAR X - LOG Y                                           *
*       =5, LOG X - LOG Y                                              *
*     (XI,YI) IS THE INTERPOLATED POINT                                *
*     NOTE- IF A NEGATIVE OR ZERO ARGUMENT OF A LOG IS                 *
*           DETECTED, THE INTERPOLATION CODE IS AUTOMATICALLY          *
*           CHANGED FROM LOG TO LINEAR                                 *
*                                                                      *
************************************************************************
*
      GO TO (40,50,60,110,140),I
*
   40 YI = YA
      GO TO 200
*
   50 YI = YA + (XI-XA)*(YB-YA)/(XB-XA)
      GO TO 200
*
   60 IF(XA.LE.0..OR.XB.LE.0.) GO TO 50
  100 YI = YA + ALOG(XI/XA)*(YB-YA)/ALOG(XB/XA)
      GO TO 200
*
  110 IF(YA.LE.0..OR.YB.LE.0.)   GO TO 50
  130 YI = YA*EXP((XI-XA)*ALOG(YB/YA)/(XB-XA))
      GO TO 200
*
  140 IF(YA.LE.0..OR.YB.LE.0.)   GO TO 60
      IF(XA.LE.0..OR.XB.LE.0.)   GO TO 130
*
  180 IF(XI.LE.0.) GO TO 100
      YI = YA*EXP(ALOG(XI/XA)*ALOG(YB/YA)/ALOG(XB/XA))
*
  200 RETURN
      END
